import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.event.*;
import java.util.Random;

/**
  *
  * Klasse fr einen intelligenten Computerspieler
  *
  * @version 1.0 vom 10.08.2008
  * @author Daniel Garmann
  */

public class ComputerSpieler extends Spieler {


  private int suchtiefe;
  private Zug zug;
  private JFrame owner;


  public ComputerSpieler(JFrame owner, int maximaleSuchtiefe)
  {
    this.owner = owner;
    this.suchtiefe = maximaleSuchtiefe;
  }
  
  private int bewertungsfunktion(Position position){
    int steine = 0;
    for (int fach = 0; fach < Position.FAECHER; fach++) {
      steine = steine + position.getFeld(fach, position.getAmZug());
    }
    for (int fach = 0; fach < Position.FAECHER; fach++) {
      steine = steine - position.getFeld(fach, 1-position.getAmZug());
    }
    return steine;
  }


  private int negamax(Position position, int tiefe)
  {
    if (position.spielendeErreicht() || (tiefe == 0))
      return -bewertungsfunktion(position);
    else {
      int wert = -Integer.MAX_VALUE;
      for (int probezugfach = 0; probezugfach < Position.FAECHER; probezugfach++) {
        if (tiefe == suchtiefe) {
          ((Gui)owner).jpgbComputer.setValue(probezugfach);
        }
        for (int probezugrichtung = -1; probezugrichtung < 2; probezugrichtung += 2) {
          Zug probezug = new Zug(probezugfach, probezugrichtung);
          if (position.zulaessig(probezugfach)) {
            Position folgePosition = position.folgePosition(probezugfach, probezugrichtung);
            int folgewert = -negamax(folgePosition, tiefe - 1);
            if (folgewert > wert) {
              wert = folgewert;
              if (tiefe == suchtiefe)
                zug = probezug;
            }
          }

        }
      }
//      if (tiefe == suchtiefe) System.out.println("Tiefe: "+tiefe+"    Zug: "+zug.gibFach()+"/"+zug.gibRichtung()+"   ("+wert+")");
      return wert;
    }
  }
  


  public Zug spielzugMachen(Position position)
  {

    if (suchtiefe > 0)
      negamax(position,suchtiefe);
    else {
      do
        zug = new Zug((int)(Math.random()*Position.FAECHER), (int)(Math.random()*2)*2-1);
      while (!position.zulaessig(zug.gibFach()));
    }
    return zug;
  }

}
