import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.event.*;

/**
  *
  * Simulation eines 3d-Viergewinnt-Spiels
  *
  * @version 1.0 vom 17.11.2008
  * @author Daniel Garmann
  */

public class Gui extends JFrame implements Runnable {
  // Anfang Attribute
  private Spiel spiel;
  private JButton jButton1 = new JButton();
  private Thread spielThread;

  public boolean menschspielerDarfSetzen = false;
  public Zug menschspielerZug;
  private ButtonGroup jButtonGroup1 = new ButtonGroup();
  private JCheckBox jcbRechts = new JCheckBox();
  public JProgressBar jpgbComputer = new JProgressBar();
  // Ende Attribute

  public Gui(String title) {
    // Frame-Initialisierung
    super (title);
    setDefaultCloseOperation(WindowConstants.EXIT_ON_CLOSE);
    int frameWidth = 646;
    int frameHeight = 405;
    setSize(frameWidth, frameHeight);
    Dimension d = Toolkit.getDefaultToolkit().getScreenSize();
    int x = (d.width - getSize().width) / 2;
    int y = (d.height - getSize().height) / 2;
    setLocation(x, y);
    Container cp = getContentPane();
    cp.setLayout(null);
    // Anfang Komponenten

    jButton1.setBounds(20, 308, 600, 40);
    jButton1.setText("Start");
    jButton1.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent evt) {
        jButton1_ActionPerformed(evt);
      }
    });
    jButton1.setFont(new Font("Arial", Font.PLAIN, 23));
    cp.add(jButton1);
    
    JButton b;
    for (int spieler = 0; spieler < 2; spieler++) {
      for (int fach = 0; fach < Position.FAECHER; fach++) {
        int px = Position.xpos[spieler][fach]*70+45;
        int py = Position.ypos[spieler][fach]*60+35;
         b = new JButton();
         b.setBounds(px,py,20,20);
         b.setText(""+spieler+"|"+fach);
         b.addActionListener(new ActionListener() {
           public void actionPerformed(ActionEvent evt) {
             b_ActionPerformed(evt);
           }
         });
         cp.add(b);
      }
    }

    jcbRechts.setBounds(24, 312, 73, 17);
    jcbRechts.setText("rechts");
    jcbRechts.setSelected(true);
    cp.add(jcbRechts);
    jpgbComputer.setBounds(16, 352, 606, 17);
    jpgbComputer.setMaximum(15);
    cp.add(jpgbComputer);
    // Ende Komponenten

    setResizable(false);
    setVisible(true);
  }

  // Anfang Methoden


  public void run() {
    spiel = new Spiel(this,0);
    spiel.starten();
  }
  
  
  public void jButton1_ActionPerformed(ActionEvent evt) {

    jButton1.setVisible(false);
    menschspielerDarfSetzen = false;

    spielThread = new Thread(this);
    spielThread.start();
  }

  public void b_ActionPerformed(ActionEvent evt) {
    // TODO hier Quelltext einfgen

    if (menschspielerDarfSetzen) {
      int spieler = Integer.parseInt(""+((JButton)evt.getSource()).getText().charAt(0));
      int fach = Integer.parseInt(""+((JButton)evt.getSource()).getText().substring(2));
      if (jcbRechts.isSelected()) {
        menschspielerZug = new Zug(fach,1);
      } else {
        menschspielerZug = new Zug(fach,-1);
      }

      menschspielerDarfSetzen = false;
    }
  }
  
  public void reset() {
    jButton1.setVisible(true);
    
  }

  // Ende Methoden

  public static void main(String[] args) {
    new Gui("Gui");
  }
}
